//               The SnakeSsoft Assember v3.1

//NOTE:
//			 place: jmp place    ; is like jmp offset place


//version 3.0 had the fancy one line per instruction, but that made
//            it very error prone and delicate. Also the convertion
//            to match was very very error prone........
//version 3.2 scrapped attempt to go back to 3.0

//Updates over SSASM v2.x
/*      : Assembler really compiles leaving less work for linker
	: Linker will be able to link
	: Is easy to include into another language as an asm command
	: HAS 32BIT PMODE OPTION :-)
	: Faster?
	: More stable, and better, neater coding structure
	: better
*/
//Assumes (if no size is given) OFFSET/SEG = WORD (pmode Dword)

//NOTE PREPROCESS MUST SPLIT MULTI INSTRUCTIONS LIKE "rep nop" TO SEPERATE
//all number to int?, and  EQU unpacking

//#include <stdio.h>
//#include <ctype.h>//for toupper
//#include <string.h>


int g_size,our_offseg;

#include "sasm.h"   // *opcodes[]

#define ASM_MAX_OPERANDS 3

//#define MAXWORDLEN 21
//#define MAX_LABEL_SIZE   MAXWORDLEN+4
//#define MAXASMLINE 51

//#define ERROR   0
//#define WARNING 1

//we use NULL for no parameters
#define NUMBER    1    //number  1234 ( this can be offset or seg as well)
#define REGISTER  2    // AL EAX etc
#define REG       2    //as above
#define DIRECT    3    // [eax+2323]
#define DIRECTNUM 4    // [1234]    //NUMBER ONLY (no regs)

//Use16, use32 directives to toggle below
//short int Pmode;      // 1 for if coding for protected mode
short int assumesize; // If no size was given, we assume it to be ...
//short output; //0=code dump, 1=COM, 2=EXE, 3=32bit dump 4=asm dump


//char *asm_str=" Mov   [eax],offset cow+12+4";
//char *asm_str=" Mov  [13],offset cow";
//char *asm_str=" Mov  [mama+1234],offset cow";
//char *asm_str="mov eax,[2+eax+cow+eax]";
//char *asm_str="fcom qword [bx+9]";
char asm_str[MAXASMLINE];
char asm_tmp[MAXASMLINE],asm_wordnext[MAXWORDLEN];
int strptr, override;  //strptr is the place in string, override is ES: etc.
//int errcnt,warcnt;

char labeltmp[ASM_MAX_OPERANDS][MAX_LABEL_SIZE]; //name
char labelset[ASM_MAX_OPERANDS+1];              //mathsym
//above lets MOV AX,[cow ^ 12] be possible
char parmtypes[ASM_MAX_OPERANDS+1];            //NUM direct etc...
char regsizes[ASM_MAX_OPERANDS+1];            //EAX =3 (so we can scan for 67/66 prefix)
char parm_amount;                               //how many
char asm_command[12];                          //the actual assembler command
char assumedsize;                       //no size was given use offset etc to set
char wanttheoff;       //read in thing sets this gobal so we know to store the label offset
char calldistance; //the far/near/short
char mustbespecialfloat; //the tbyte,qword
char mustbespecialreg;
unsigned char rbytes[9];//for the reversed bytes

//int off_set;    //so we can tell where the labels are
//unsigned long off_set;    //so we can tell where the labels are
int gobaltmp;  //anything var
int mainptr;//the tmp line byte pointer
int regtype, regnumber;
short int relative;//is the offset IP-/+place or place?

unsigned long gobaltstnumber;
char gobaltstnumberset=0;

//NOTE any reg below repeating is cause intel say it not exist
//	so for maths reasons it is as such
char *specialreg[]={ "DR0","DR1","DR2","DR3","DR3","DR3","DR6","DR7",
		     "TR4","TR5","TR6","TR7","TR7","TR7","TR7","TR7",
		     "CR0","CR2","CR3",NULL };


//Error messages
char *un_eol="Unexpected end of line.";
char *syn_tax="Syntax error.";
char *inv_over="Invalid use of a segment override.";
char *inv_oper="Invalid operands.";
char *not_dir_dir="Cannot be direct,direct.";
char *inv_reg="Invalid register in direct memory access.";
char *inv_reg2="Invalid register operation.";
char *inv_asm="Invalid assembler command.";
char *need_size="Size unknown.";
char *inv_short="Cannot be SHORT, using NEAR.";
char *inv_far="Cannot be FAR.";

//Registers
char *reg8[]={  "AL","CL","DL","BL","AH","CH","DH","BH",NULL };
char *reg16[]={ "AX","CX","DX","BX","SP","BP","SI","DI",NULL };
char *reg32[]={ "EAX","ECX","EDX","EBX","ESP","EBP","ESI","EDI",NULL };
char *segs[]={ "ES","CS","SS","DS","FS","GS",NULL };
char *direct16[]={ "BX+SI","BX+DI","BP+SI","BP+DI","SI","DI","BP","BX",NULL };//x+x maybe reversed but =the same


//Sub COde
void number_get(int size, int parmnum);//uses gobaltstnumber (so don't use with MOV DR0 etc
void do_reg_regAB(); //Handle the REG,REG as this code is always the same
		      //Dave's idea....
int isaspecialreg(char *str);//returns specialreg in array place+1 or 0
void error(char *str, int err);
void asm_skipspaces();
int asm_getnextword();
int asm_processA();     //the asm_str to asm_tmp
int isreg(char *str);   //is the thing a register/segment
unsigned long maths(unsigned long total, unsigned long num, int mathsym);
int isvalid_direct(char *str); //is valid [bx]
int asm_to_hex(); //the compile of asm_tmp
int do_square(int first, int size, int regsize, int parmnum); //handle the [reg]
int regvalue(char *regstring,int bit);
void reversebytes(unsigned long number);//reverse the bytes in nmber (sets *rbytes)
int do_number(int hasdirect, int size, int parmnum, int addseg); //handle the 1234 (This reverses and label checks)
void reverse(); //reverse the operands
int read_reg(); //set regtype, regnumber


int validletter(int tst){//ret 1 if is
  tst=toupper(tst);
  if(tst>='A' && tst<='Z') return 0;
  if(tst=='!' || tst=='_' || tst=='@') return 0;
  if(tst>='0' && tst<='9') return 0;
return 1; }

/*void write_inst(unsigned char byte){
  printf("%.2x(%d),",byte,byte); //at the minute we'll just print it
  off_set++;
return; }
void add_relative_mark(int size){ //these are for IP-/+
  if(size==0)size=3;//this is the way do_number handles it
 printf(" (relative number %d (size=%d)) ",off_set,8*size);
}
void addlabeloffsetstore(int offset,int type, int mathsym, char *name, int size){ //we store it
 printf("Offset %u+MASTEROFFSET ((type=%d) %c %s (BYTES to write %d))\n",offset,type,mathsym,name,size);
 //type==1 [0000]  (offset)
 //type==2  0000   (offset)  write SIZE amount (1,2,4 bytes) for all
 //type==3  0000   (segment)
 
 //mathsym is what we do to what's there
 //offset is the extra position we add
 
}*/

//return 0 OKAY
//       1 Nothing to do
//       2 had error
int asm_main(){//argc,argv) int argc; char *argv[]; {
 int tst;//,tst2;

//main must reset these
// errcnt=0; warcnt=0;
// assumesize=0;//2+Pmode;
// Pmode=0;
// output=2; //0=code dump, 1=COM, 2=EXE, 3=32bit dump

// printf("Before = %s\n",asm_str);

 tst=asm_processA();    //the asm_str to asm_tmp

 if(tst>0)return tst;//nothing to do/error
 //else
// printf("After = %s\n",asm_tmp);
 if(tst==0){ //otherwise ther was an error (or blank line)
//         printf("Command = %s\n",asm_command);
	 //off_set=0;
	 if(override!=0){
		    switch(override-1){
			      case 0: write_inst(0x26); break; //ES:
			      case 1: write_inst(0x2E); break; //CS:
			      case 2: write_inst(0x36); break; //SS:
			      case 3: write_inst(0x3E); break; //DS:
			      case 4: write_inst(0x64); break; //FS:
			      case 5: write_inst(0x65); break; //GS:
			      default: error("Invalid override.",ERROR);
				}//the switch
			}
	 tst=asm_to_hex();
         if(tst!=0)return 1;

         if(our_offseg>0 && g_size==1)error("Incompatiable sizes.",ERROR);
         if(Pmode==1 && our_offseg>0 && g_size==2)error("Incompatiable sizes.",ERROR);

 //      printf(" parmaeters = %d ",parm_amount);
//       for(tst=0; tst<parm_amount; tst++){
//              tst2=parmtypes[tst];
//              if(tst2==NULL) { printf("NO parameters"); break; }
//              else if(tst2==NUMBER) printf(" Number (1234 etc)");
//              else if(tst2==REGISTER) printf(" Register (AX etc) ");
//              else if(tst2==DIRECT) printf(" Direct ( [12+BX] etc) ");
//              else if(tst2==DIRECTNUM) printf(" DIRECTNUM ( [1234] etc) ");
//              else printf(" Error %d ",tst2);
//                      }
	}
return 0; }


#include "asmtohex.h"


/*******************************************
	The asm_str to asm_tmp
	----------------------
     returns: 0 success,
	      1 nothing to do (blank str)
	      else error
*******************************************/
int asm_processA(){
    int parms,size=0,direct,tmp,offseg=0;
    int bptr;
    unsigned char tst1,tst2,tst3;

    unsigned long totalnumb,lastwasdirect;
    long tmpnumb;
    int cntr,isminus,mathsym,hasnum,hasreg,noreg,regcnt,regsetsize=0;
    int thisislabel=0;
    unsigned char regs[3];//for parameters
    char tmpplace[20];//for print numbers in
    short waslabel,f_u=0,not_offset=0;

    g_size=0; our_offseg=0;
    gobaltstnumber=0; gobaltstnumberset=0;

    mustbespecialreg=0;//the dr0 etc
    mustbespecialfloat=0;//tbyte, qword, st
    asm_command[0]=0;//just incase
    override=0; strptr=0; asm_tmp[0]=0;
    strcpy(asm_tmp,"?"); //the size ptr
    assumedsize=0;
    calldistance=0;
     parm_amount=0;
     parmtypes[0]=0;//NULL;
     regsizes[0]=0; regsizes[1]=0; regsizes[2]=0;
    //A get command
    //B loop for operands with minimum (basic) error checking

    //A:
    if(asm_getnextword()==1)return 2;
    if(asm_wordnext[0]==0)return 1;
    if(strlen(asm_wordnext)>11) { error(inv_asm,ERROR); return 2; }
    //strcat(asm_tmp,asm_wordnext);  //  ?MOV
    //strcat(asm_tmp," ");  //  ?MOV
    strcpy(asm_command,asm_wordnext);

    lastwasdirect=0;
    //B:
    //test for float reg st(),st
    bptr=strptr;
    
    asm_skipspaces(); 
	tst1=asm_str[strptr++]; tst1=toupper(tst1);
	tst2=asm_str[strptr++]; tst2=toupper(tst2);
	tst3=asm_str[strptr]; tst3=toupper(tst3);//printf("  %c %c %c ",tst1,tst2,tst3);
	if(tst3!=0)strptr++;
    if(validletter(tst3)==0)goto donetst;
    if(tst3==32){ asm_skipspaces(); tst3=asm_str[strptr]; 
    			  tst3=toupper(tst3);if(tst3!=0)strptr++; }
    if(tst3=='(' || tst3==0);
	else tst3=0;
    if(tst1=='S' && tst2=='T');// && tst3!=0);
    else goto donetst;
	mustbespecialfloat=100;//MUST BE A FLOAT'R COMMAND    
	parm_amount=1;
    if(tst3=='('){
    		asm_skipspaces();
    		tst2=asm_str[strptr++];
            if(tst2<'0' || tst2>'7'){ error("Valid FPU register numbers 0 to 7.",ERROR); return 2; }
            asm_skipspaces();
            tst1=asm_str[strptr++];
            if(tst1!=')'){ error("Missing )",ERROR); return 2; }//must be )
            parmtypes[0]=tst2;
                 	}
	else parmtypes[0]=10;
	asm_skipspaces();
	tst1=asm_str[strptr++];	
//printf("%c (%d)",tst1,tst1);	
	if(tst1==0) return 0;
	else if(tst1!=',') { error(inv_oper,ERROR); return 2; }
	parm_amount=2;
	tst1=asm_str[strptr++]; tst1=toupper(tst1);
	tst2=asm_str[strptr++]; tst2=toupper(tst2);
	tst3=asm_str[strptr]; tst3=toupper(tst3);
	if(tst3!=0)strptr++;
	if(validletter(tst3)==0){ error(inv_oper,ERROR); return 2; }
    if(tst3==32){ asm_skipspaces(); tst3=asm_str[strptr];
    			 tst3=toupper(tst3);if(tst3!=0)strptr++; }
    if(tst3=='(' || tst3==0);
	else tst3=0;
    if(tst1=='S' && tst2=='T');// && tst3!=0);
    else { error(inv_oper,ERROR); return 2; }
    if(tst3=='('){
	    if(parmtypes[0]!=10){ error(inv_oper,ERROR); return 2; }
	        asm_skipspaces();
    		tst2=asm_str[strptr++];
            if(tst2<'0' || tst2>'7'){ error("Valid FPU register numbers 0 to 7.",ERROR); return 2; }
            asm_skipspaces();
            tst1=asm_str[strptr++];
            if(tst1!=')'){ error("Missing )",ERROR); return 2; }//must be )
            parmtypes[1]=tst2;
	              }
	else {  if(parmtypes[0]==10){ error(inv_oper,ERROR); return 2; }
			parmtypes[1]=10;	}
	asm_skipspaces();
	tst1=asm_str[strptr++];
	if(tst1==0) return 0;
	else { error(inv_oper,ERROR); return 2; }
donetst:
    strptr=bptr;
    for(parms=0; parms<ASM_MAX_OPERANDS; parms++){
	//Get the non operand information
	direct=0; offseg=0; if(thisislabel==1)thisislabel=2;
	noreg=0;
	if(asm_getnextword()==1)return 2;
	if(asm_wordnext[0]==0){ if(parms>0){ error(un_eol,ERROR); return 2; }
				break; //eol
					}
	parm_amount++; //One parameter at least
	tmp=0;
	waslabel=0;
	if(!stricmp(asm_wordnext,"SHORT")) tmp=1;
	else if(!stricmp(asm_wordnext,"NEAR")) tmp=2;
	else if(!stricmp(asm_wordnext,"FAR")) tmp=3;
	if(tmp!=0){ if(calldistance!=0) { error(inv_oper,ERROR); return 2; }
		    calldistance=tmp;
		    if(asm_getnextword()==1)return 2;
		    if(asm_wordnext[0]==0){ error(un_eol,ERROR);//unepxected eol
				       return 2; }
		    if(!stricmp(asm_wordnext,"PTR")){
				if(asm_getnextword()==1)return 2;
				 if(asm_wordnext[0]==0){ error(un_eol,ERROR);return 2; }
					    }
		    }
	if(asm_wordnext[0]=='['){
				if(direct==1){ error(syn_tax,ERROR);//syntax error
					      return 2; }
				direct=1;
				if(asm_getnextword()==1)return 2;
				if(asm_wordnext[0]==0){ error(un_eol,ERROR);//unepxected eol
						       return 2; }
                                not_offset=1;
                                }
	tmp=0;

	if(!stricmp(asm_wordnext,"DWORD")||
			!stricmp(asm_wordnext,"DWORDPTR")) size=3, tmp=1;
	else if(!stricmp(asm_wordnext,"WORD")||
			!stricmp(asm_wordnext,"WORDPTR")) size=2, tmp=1;
	else if(!stricmp(asm_wordnext,"BYTE")||
			!stricmp(asm_wordnext,"BYTEPTR")) size=1, tmp=1;
	else if(!stricmp(asm_wordnext,"TBYTE")||
			!stricmp(asm_wordnext,"TBYTEPTR")) size=4, tmp=1;
	else if(!stricmp(asm_wordnext,"QWORD")||
			!stricmp(asm_wordnext,"QWORDPTR")) size=5, tmp=1;
	if(tmp==1){ if(asm_getnextword()==1)return 2;
		    if(asm_wordnext[0]==0){ error(un_eol,ERROR);//unepxected eol
				       return 2; }
		    if(!stricmp(asm_wordnext,"PTR")){
				if(asm_getnextword()==1)return 2;
				 if(asm_wordnext[0]==0){ error(un_eol,ERROR);return 2; }
					    }
		   }
	asm_skipspaces();
//OKAY
	tmp=isreg(asm_wordnext);
//ERROR fixed
	if(tmp<30)tmp=0;
	if(tmp>0 && asm_str[strptr]==':'){ strptr++;//past it
					   if(override!=0){ error(inv_over,ERROR); return 2; }
					   override=tmp-30;
					   if(asm_getnextword()==1)return 2;
					   if(asm_wordnext[0]==0){ error(un_eol,ERROR);//unepxected eol
							       return 2; }
					   }
	if(asm_wordnext[0]=='['){
				if(direct==1){ error(syn_tax,ERROR); return 2; }
				direct=1;
				if(asm_getnextword()==1)return 2;
				if(asm_wordnext[0]==0){ error(un_eol,ERROR); return 2; }
				asm_skipspaces();
                                not_offset=1;
				}        
	tmp=isreg(asm_wordnext);
	if(tmp<30)tmp=0;
	if(tmp>0 && asm_str[strptr]==':'){ strptr++;//past it
					   if(override!=0){ error(inv_over,ERROR); return 2; }
					   override=tmp;
					   if(asm_getnextword()==1)return 2;
					   if(asm_wordnext[0]==0){ error(un_eol,ERROR);//unepxected eol
							       return 2; }
					   }
	tmp=0;
	if(!stricmp("OFFSET",asm_wordnext)) offseg=1,tmp=1;
	else if(!stricmp("SEG",asm_wordnext)) offseg=2,tmp=1;
	if(tmp==1){ if(asm_getnextword()==1)return 2;
		    if(asm_wordnext[0]==0){ error(un_eol,ERROR);return 2; }
		    assumedsize=2+Pmode;
		   }
	if(direct==1 && lastwasdirect==1){ error(not_dir_dir,ERROR);
					   return 2; }
	//get the operand
	 isminus=0; mathsym='+'; totalnumb=0;
	 hasnum=0; hasreg=0; regcnt=0;
	 while(1){
	       if(asm_wordnext[0]=='-') { isminus=1;
					   if(asm_getnextword()==1)return 2;
					   if(asm_wordnext[0]==0){ error(un_eol,ERROR);return 2; }
					   }
		tmp=asm_wordnext[0];
		if(tmp>='0' && tmp<='9'){//is number
				if(hasreg==1 && direct==0) { error(inv_oper,ERROR); return 2; }
				     tmpnumb=0; cntr=0;
 					 hasnum=1;
					  while(1){
					     tmp=asm_wordnext[cntr++];
					     if(tmp==0)break;
					     tmpnumb*=10;
					     tmpnumb+=tmp-'0';
					      }
					 if(isminus==1) tmpnumb=-tmpnumb;
					 totalnumb=maths(totalnumb,tmpnumb,mathsym);
					 }
		else if((tmp=isaspecialreg(asm_wordnext))>0){
					if(mustbespecialreg>0 || hasreg==1){ error(inv_oper,ERROR); return 2; }   //only one reg if not direct
					mustbespecialreg=tmp;//DR0 etc
					hasreg=1;
					regs[regcnt]=100;//add our reg
					regcnt++;
					size=3;
					regsetsize=size;
					}
		else if((tmp=isreg(asm_wordnext))!=0){//  be register
				if(hasreg==1 && direct==0) { error(inv_oper,ERROR); return 2; }   //only one reg if not direct
				if(noreg==1) { error(inv_oper,ERROR); return 2; }//no reg with label
				if(direct==1 && ( tmp<11 || tmp>30)) { error(inv_reg,ERROR); return 2; } //No 8bit or seg in direct
				if(regcnt==2){error("Too many registers in direct memory access.",ERROR); return 2; } //only two in direct
				if(direct==1 && mathsym!='+') { error("Can only be +Reg.",ERROR); return 2; }
				hasreg=1;
				regs[regcnt]=tmp;//add our reg
				if(regcnt>0 && ((tmp>20 && regs[regcnt-1]<20) || (tmp<20 && regs[regcnt-1]>20))){error("Different register sizes.",ERROR); return 2; } //MUST be compatiable
				regcnt++;
				if(direct==0){
					if(tmp<10) size=1;
					else if(tmp<20) size=2+Pmode;
					else if(tmp<30) size=3;
					else size=2+Pmode;
                                        if(regsetsize==0)regsetsize=size;
					 }
				  }
		else{// Must be label
                        if(not_offset==0 && offseg==0)offseg=1;
			if(validletter(asm_wordnext[0])==1){ error(syn_tax,ERROR); return 2; }
			if(lastwasdirect==1 && offseg==0) { error(not_dir_dir,ERROR); return 2; }
			if(offseg==0) lastwasdirect=1;//cannot be [eax],label
			//if(noreg==1) {error(inv_oper,ERROR); return 2; }//only one label per line
//printf("MY FAULT");			
			if(thisislabel==2 && offseg==0){error(inv_oper,ERROR); return 2; }//only one label per line
//printf("notMY FAULT");
			//if(regcnt>0) {error(inv_oper,ERROR); return 2; }//cannot be EAX+label
			//Above, it can actually!!!!!!
			//noreg=1;
			thisislabel=1;
			tmp=strlen(asm_wordnext)+1;
			if(tmp>MAX_LABEL_SIZE){ asm_wordnext[MAX_LABEL_SIZE-1]=0;
						 error("Label too long, truncated.",WARNING);
						 }
			strcpy(labeltmp[parms],asm_wordnext);
			labelset[parms]=mathsym;
				}
		//Wantmathsym
		//if(output==2 && offseg==2){ error("Cannot do maths with SEGMENT.",ERROR); return 2; }
		if(asm_getnextword()==1)return 2;
		tmp=asm_wordnext[0];
                 //if(tmp!=']' && tmp!=0 && offseg==2){ error("Cannot do maths with SEGMENT.",ERROR); return 2; }
                 f_u=0;
                 if(tmp=='+') mathsym='+',f_u=1;
                 else if(tmp=='-') mathsym='-',f_u=1;
                 else if(tmp=='/') mathsym='/',f_u=1;
                 else if(tmp=='*') mathsym='*',f_u=1;
                 else if(tmp=='^') mathsym='^',f_u=1;
                 else if(tmp=='|') mathsym='|',f_u=1;
                 else if(tmp=='&') mathsym='&',f_u=1;
                 else if(tmp=='%') mathsym='%',f_u=1;
		 else if(tmp=='>' || tmp=='<') {   if(tmp=='<')mathsym='<';
					      else mathsym='>';
                                                f_u=1;
						if(asm_getnextword()==1)return 2;
						if(asm_wordnext[0]==0){ error(un_eol,ERROR);return 2; }
						if(asm_wordnext[0]!=tmp){ error("Invalid Maths symbol.",ERROR); return 2; }
						if(asm_getnextword()==1)return 2;
						if(asm_wordnext[0]==0){ error(un_eol,ERROR);return 2; }
				    }
		 else break;
                 if(f_u==1 && offseg==2){ error("Cannot do maths with SEGMENT.",ERROR); return 2; }
		if(asm_getnextword()==1)return 2;
		if(asm_wordnext[0]==0){ error(un_eol,ERROR);return 2; }
		     }//the while(1)
	     //TIDY UP THE OPERANDS
	     if(direct==1 && noreg==0){
		       if(regcnt>0){ //reg (+reg)
				 strcat(asm_tmp,"[");
				 tmp=regs[0];
				 if(tmp<10) {error(inv_reg,ERROR); return 2;} //strcat(asm_tmp,reg8[tmp-1]);//al etc
				 else if(tmp<20){ //16 biters are special
						if(regcnt==1){  //oneparamter, we let elsewhere handle if 2
							 if(isvalid_direct(reg16[tmp-11])==1) { sprintf(tmpplace,"R%d",gobaltmp);
												strcat(asm_tmp,tmpplace);
												// strcat(asm_tmp,reg16[tmp-11]);//ax etc
												}
									}
					      regsizes[parms]=2;
						}
				 else if(tmp<30){// strcat(asm_tmp,reg32[tmp-21]);//eax etc
						sprintf(tmpplace,"E%d",tmp-20);
						strcat(asm_tmp,tmpplace);
						regsizes[parms]=3; }
				 else {error(inv_reg,ERROR); return 2;}   //strcat(asm_tmp,segs[tmp-31]);//es etc
				 if(regcnt>1){
					 tmp=regs[1];
					 if(tmp<10) {error(inv_reg,ERROR); return 2;} //strcat(asm_tmp,reg8[tmp-1]);//al etc
					 else if(tmp<20){ //strcat(asm_tmp,reg16[tmp-11]);//ax etc
						  strcpy(tmpplace,reg16[regs[0]-11]);
						  strcat(tmpplace,"+");
						  strcat(tmpplace,reg16[regs[1]-11]);
						  tmp=isvalid_direct(tmpplace);
						  if(tmp==0) { error(inv_reg,ERROR); return 2; }
						  else {//if(tmp==1) strcat(asm_tmp,tmpplace);
							sprintf(tmpplace,"R%d",gobaltmp);
							strcat(asm_tmp,tmpplace);
								}
						  //else {//reverse
							//  strcpy(tmpplace,reg16[regs[1]-11]);
							//  strcat(tmpplace,"+");
							//  strcat(tmpplace,reg16[regs[0]-11]);
							//  strcat(asm_tmp,tmpplace);
						  //                    }
								}
					 else if(tmp<30){//strcat(asm_tmp,"+");
							// strcat(asm_tmp,reg32[tmp-21]);//eax etc
							sprintf(tmpplace,"%d",tmp-20);
							strcat(asm_tmp,tmpplace);
							 }
					 else {error(inv_reg,ERROR); return 2;} //strcat(asm_tmp,segs[tmp-31]);//es etc
					      }
			if(thisislabel==1){//+label
//LABEL SIZE MUST MATCH REG SIZE !!!!!!!! or be 8bit (umless offset>0)
					  // if(offseg!=0){
				  	   waslabel=1;
					   strcat(asm_tmp,"+");
					   if(offseg==2) strcat(asm_tmp,"\3");//want the segment
					   else strcat(asm_tmp,"\2");//want the offset
					   sprintf(tmpplace,"%lu",totalnumb);
					   strcat(asm_tmp,tmpplace); // 0000 (+number entered)
					   //	}
					   // else { strcat(asm_tmp,"\1");//normal label [0000]
					  	//	  if(direct==0 && hasnum==1) { error(inv_oper,ERROR); return 2; }
					  	//	  if(direct==0) totalnumb=0;
					  	//	  sprintf(tmpplace,"[%lu]",totalnumb);
					  	//	  strcat(asm_tmp,tmpplace); //[0000]  (+number entered)
					  	//	}
				   		}
				else if(hasnum!=0){//+num
				      sprintf(tmpplace,"+%lu",totalnumb);
				      strcat(asm_tmp,tmpplace);
						}
				 strcat(asm_tmp,"]");
				}
		       else{  //[number]
		       //printf("HERE %d\n",thisislabel);
		       	  if(thisislabel==1){//+label
//LABEL SIZE MUST MATCH REG SIZE !!!!!!!! or be 8bit (umless offset>0)
				  	   waslabel=1;
					   if(offseg==2) strcat(asm_tmp,"\3");//want the segment
					   else strcat(asm_tmp,"\1");//want the offset
					   strcat(asm_tmp,"[");
					   sprintf(tmpplace,"%lu",totalnumb);
					   strcat(asm_tmp,tmpplace); // 0000 (+number entered)
					   strcat(asm_tmp,"]");
					   	}
				   else{
			     	sprintf(tmpplace,"[%lu]",totalnumb);
			     	strcat(asm_tmp,tmpplace);
			     		}
			    }
			}
	     else if(noreg==0 && thisislabel!=1){ //NUMBER or REGISTER
			if(regcnt>0){//register
				if(hasnum!=0) { error(inv_oper,ERROR); return 2; }
				 tmp=regs[0];
				 if(tmp>99 && mustbespecialreg>0){
						 strcat(asm_tmp,specialreg[mustbespecialreg-1]);
						 regsizes[parms]=99;
							}
				 else if(tmp<10) { strcat(asm_tmp,reg8[tmp-1]);//al etc
					      regsizes[parms]=1; }
				 else if(tmp<20) { strcat(asm_tmp,reg16[tmp-11]);//ax etc
					      regsizes[parms]=2; }
				 else if(tmp<30) { strcat(asm_tmp,reg32[tmp-21]);//eax etc
					      regsizes[parms]=3; }
				 else { strcat(asm_tmp,segs[tmp-31]);//es etc
					      regsizes[parms]=2; }
					}
			 else{//number
			     if(parm_amount==2) { gobaltstnumber=totalnumb;
						  gobaltstnumberset=1;
						  }
			      sprintf(tmpplace,"%lu",totalnumb);
			      strcat(asm_tmp,tmpplace);
			      regsizes[parms]=0; //doesmatter
				}
			}
	    else { //LABEL
	       waslabel=1;
		   if(offseg!=0){
			   if(offseg==2) strcat(asm_tmp,"\3");//want the segment
			   else strcat(asm_tmp,"\2");//want the offset
			   sprintf(tmpplace,"%lu",totalnumb);
			   strcat(asm_tmp,tmpplace); // 0000 (+number entered)
			}
		   else { strcat(asm_tmp,"\1");//normal label [0000]
			  if(direct==0 && hasnum==1) { error(inv_oper,ERROR); return 2; }
			  if(direct==0) totalnumb=0;
			  sprintf(tmpplace,"[%lu]",totalnumb);
			  strcat(asm_tmp,tmpplace); //[0000]  (+number entered)
				}
		  regsizes[parms]=0;//doesn't matter
//set size to what ever size it's size is DEBUG HERE BEDUG HERE
			}
	     //WANT , or ],
	     if(asm_wordnext[0]==']' && direct==0) {error("Unexpected ]",ERROR); return 2; }
	     if(asm_wordnext[0]!=']' && direct==1) {error("Expected ]",ERROR); return 2; }
	     if(asm_wordnext[0]==']')   if(asm_getnextword()==1)return 2;

	     //set the parameter type
	     if(direct==1 || (waslabel==1 && offseg==0)){ if(regcnt==0) parmtypes[parms]=DIRECTNUM;
			    else parmtypes[parms]=DIRECT;
			    //direct=1;
				}
	     else if(regcnt>0) parmtypes[parms]=REGISTER;
	     else if(noreg!=0){ if(offseg!=0) parmtypes[parms]=NUMBER;
				else  parmtypes[parms]=DIRECTNUM;
				}
	     else parmtypes[parms]=NUMBER;

	    // if(offseg!=0 && noreg==0){ error("Label expected.",ERROR); return 2; }
	    if(offseg!=0 && waslabel==0){ error("Label expected.",ERROR); return 2; }
        if(direct==0 && override!=0) { error(inv_over,ERROR); return 2; }

	     if(asm_wordnext[0]==0)break;
	     if(asm_wordnext[0]==':') calldistance=3;
	     else if(asm_wordnext[0]!=','){ error(inv_oper,ERROR); return 2; }
	     strcat(asm_tmp,",");
	     if(direct==1)lastwasdirect=1;
	}//the for...
    //MUST BE EOL...
   if(asm_getnextword()==1)return 2;
   if(asm_wordnext[0]!=0) error("Ignoring unknown stuff at end of line.",WARNING);

   if(size==4 || size==5) mustbespecialfloat=size-3,size=0;
   if(regsetsize!=0)size=regsetsize;//reg takes preference

//printf("!%d!\n",regsetsize);

   if(size==0)size=assumedsize;
   //if(size==0)size=assumesize;
   if(size==1) asm_tmp[0]='<'; //BYTE PTR
   if(size==2) asm_tmp[0]='|'; //WORD PTR
   if(size==3) asm_tmp[0]='>'; //DWORD PTR

   our_offseg=offseg;
return 0; }




// Gets the next word in asm_str (return 1=error)
int asm_getnextword(){
	int test,isnum=0,cnt=0;
	asm_skipspaces();
	asm_wordnext[0]=0;//just incase nothing
     while(1){
	 test=asm_str[strptr];
	 if(test==9 || test==32 || test==0)break;
	 if(validletter(test)==1){ if(cnt>0) break;
				   else{ strptr++;
					asm_wordnext[cnt++]=test; break; }
				    }
	 if(isnum==1 && ( test<'0' || test>'9')) { error("Invalid number.",ERROR); return 1; }
	 if(test>='0' && test<='9' && cnt==0) isnum=1;
	 asm_wordnext[cnt++]=test;
	 if(cnt>=MAXWORDLEN-1){ error("Word too long.",ERROR); return 1; }
	 strptr++;
		}
     asm_wordnext[cnt]=0;//null terminate
return 0; }


//Skip spaces in asm_str
void asm_skipspaces(){
   int test;
   while(1){
       test=asm_str[strptr];
       if(test!=32 && test!=9) return;
       strptr++;
	}
}

//prints the error message
//void error(char *str, int err){
// if(err==ERROR){ errcnt++; printf("Error: "); }
// else { warcnt++; printf("Warning: "); }
// printf("%s\n",str);
//return; }

//Handle the maths (simple)
unsigned long maths(unsigned long total, unsigned long num, int mathsym){
   switch(mathsym){
	case '-': return total-=num;
	case '*': return total*=num;
	case '/': if(num==0) return total; return total/=num;
	case '^': return total^=num;
	case '%': return total%=num;
	case '|': return total|=num;
	case '&': return total&=num;
	case '<': return total<=num;
	case '>': return total>=num;
	default: return total+=num; // +
	      }//the switch
}

int isreg(char *str){
 int a;
 //printf("%s ",str);
 //for(a=0; a<8; a++) if(!stricmp(str,reg8[a])) return a+1;
 for(a=0; ; a++){ if(reg8[a]==NULL)break;
 				  if(!stricmp(str,reg8[a])) return a+1; }
 for(a=0; ; a++){ if(reg16[a]==NULL)break;
 				  if(!stricmp(str,reg16[a])) return a+11; }
 for(a=0; ; a++){ if(reg32[a]==NULL)break;
 				  if(!stricmp(str,reg32[a])) return a+21; }
 for(a=0; ; a++){ if(segs[a]==NULL)break;
 				  if(!stricmp(str,segs[a])) return a+31; }
return 0; }


//returns 0 NOPE 1 OK 2 reverse
int isvalid_direct(char *str){
 int a;
 gobaltmp=0;
 //normal
 for(a=0; a<8; a++) if(!stricmp(str,direct16[a])){ gobaltmp=a+1;  return 1; }
 //reverse
 if(!stricmp(str,"SI+BX")) { gobaltmp=1; return 2; }
 if(!stricmp(str,"DI+BX")) { gobaltmp=2; return 2; }
 if(!stricmp(str,"SI+BP")) { gobaltmp=3; return 2; }
 if(!stricmp(str,"DI+BP")) { gobaltmp=4; return 2; }
return 0; }

/**********************************************************
	Handle the number according to the size
	REVERSES the number
	Check for label etc...
	return 0 OK , else error
**********************************************************/
int do_number(int hasdirect,int size, int parmnum, int addseg){
 int tst,islabel=0;
 unsigned long number=0;
    // (check for label id etc)
    tst=asm_tmp[mainptr];
    if(tst==1 || tst==2 || tst==3) { mainptr++; islabel=tst; }//LABEL
	    //  if(offseg==2) strcat(asm_tmp,"\3");//want the segment  0000
	    //   else strcat(asm_tmp,"\2");//want the offset   0000
	    //    strcat(asm_tmp,"\1");//normal label [0000]
    if(hasdirect==1) { tst=asm_tmp[mainptr++];
                       if(tst!='['){ error("[ Expected.",ERROR); return 1; }
		       }
    else if(relative==1) add_relative_mark(size);
   //read in number
  while(1){
	tst=asm_tmp[mainptr];
	if(tst<'0' || tst>'9')break;
	mainptr++;
	number*=10;
	number+=tst-'0';
	}
  reversebytes(number);//reverse the number

   if(hasdirect==1) { tst=asm_tmp[mainptr++];
		      if(tst!=']'){ error("] Expected.",ERROR); return 1; }
		      }

  //LABEL POSITION IS  off_set
  if(islabel>0){
		//use parmnum to get name and mathsym
//char labeltmp[ASM_MAX_OPERANDS][MAX_LABEL_SIZE]; //name
//char labelset[ASM_MAX_OPERANDS+1];              //mathsym
                addlabeloffsetstore(off_set,islabel+addseg,labelset[parmnum],labeltmp[parmnum],size);
			}

  //write the number according to the size
  if(size==1) write_inst(rbytes[0]);
  else if(size==2){ write_inst(rbytes[0]);
		    write_inst(rbytes[1]); }
  else { write_inst(rbytes[0]);
	 write_inst(rbytes[1]);
	 write_inst(rbytes[2]);
	 write_inst(rbytes[3]); }
return 0; }


/**********************************************************
      Add the [bx] etc directly
      to the buildcommand string

      returns 0 ok else error

 No need to worry about labels as these all have registers
***********************************************************/
int do_square(int first, int size, int regsize, int parmnum){
  char directstr1[7],directstr2[5],directbits;
  int tst,getnum=0,directsize=0,directnumb,islabel=0;//letoptimize=1,
  unsigned long directnumbvalue=0;

  //here
  char islabelso=0;

  //directsize = 1(16bit) 2=32bit
  //directnumb = 0(none) 1(8bit) 2(other)
  //directnumbvalue = the value (string 00000001)
  //directbits = 1 (Eax) 2(eax+eax)
  //directstr1 = "Eax" || "Bx+SI"
  //directstr2 = "Eax" || 0

  if(size==0)directnumb=0;
  else if(size==1)directnumb=1;
  else directnumb=2;

  directbits=1;
  //we'll set directnumbvalue,directstr1,directstr2
  //send us directsize

  //send us number size
  //a: read registers, number
  //b: sprintf(directnumbvalue,"%.8x",number)
  //c: use size to set directnumb=0;

 //read in the string to the approiate places
 tst=asm_tmp[mainptr++];
//printf("%c",tst);
 if(tst!='['){ error("[ Expected.",ERROR); return 1; }

 if(regsize==3){
	directsize=2;
	directstr2[0]=0;//null terminate
	tst=asm_tmp[mainptr++];
	if(tst!='E') { error("INTERNAL: Lost the plot.",ERROR); return 1; }
	tst=asm_tmp[mainptr++]-'0';
	sprintf(directstr1,"%s",reg32[tst-1]);
	tst=asm_tmp[mainptr++];
	if(tst==']');
	else if(tst=='+')getnum=1; //get number
	else{ directbits=2;
	      sprintf(directstr2,"%s",reg32[tst-1]);
	      tst=asm_tmp[mainptr++];
	      if(tst=='+')getnum=1; //get number
			}
     }//if regsize==3
 else{ //16bit
	directsize=1;
	directstr2[0]=0;
	tst=asm_tmp[mainptr++];
	if(tst!='R') { error("INTERNAL: Lost the plot.",ERROR); return 1; }
	tst=asm_tmp[mainptr++]-'0';
	sprintf(directstr1,"%s",direct16[tst-1]);
	tst=asm_tmp[mainptr++];
	if(tst=='+') getnum=1;//get number
	}//the else

 if(getnum==1){
	  tst=asm_tmp[mainptr];
          //here
          //letoptimize=1;
	  if(tst==1 || tst==2) { mainptr++;//use offset or segment
				 islabel=tst;
                                 islabelso=1;
	  //above also make sure directnumber will not be optimized away
          //here
          //                      letoptimize=0;
				}
	while(1){
	  tst=asm_tmp[mainptr++];
	  if(tst==']' || tst==0)break;
	  directnumbvalue*=10;
	  directnumbvalue+=tst-'0';
		}//the while(1)
	}//the getnum
 //here
 //if(letoptimize==1 && directnumbvalue<256) directnumb=1; //8bit number
 //else directnumb=2;//16/32 bit (address needs this)

// printf("> %s+%s+%lu <",directstr1,directstr2,directnumbvalue); return 0;
//here
// if(letoptimize==1 && directnumbvalue==0) directnumb=0;//optimize : )
// else
 reversebytes(directnumbvalue);//reverse the number

// byt=0;
 //direct$ is for example Reg+REg-number
//67 prefix if E (set flag)

//if 16bit
if(directsize==1){//16bit in the box[]     remember [bx+si] is single
 switch(directnumb){
     case 0:    //nonumber
      write_inst(first+regvalue(directstr1,4));
       break;
     case 1:    //8bit number
      write_inst(first+0x40+regvalue(directstr1,4));
      write_inst(rbytes[0]);      //write_inst(rbytes[1]);
	break;
     case 2://16bit number
      write_inst(first+0x80+regvalue(directstr1,4));
      //here
      //if(letoptimize==0)
      if(islabelso)addlabeloffsetstore(off_set,islabel,labelset[parmnum],labeltmp[parmnum],2);
      write_inst(rbytes[0]);
      write_inst(rbytes[1]);      //write_inst(rbytes[2]); write_inst(rbytes[3]);
	}// switch
      }//the if reg in  [ ] is 16bit
else {  //Must be 32 bit Eax with the 67h prefix (which is not our problem)
 if(directbits==1){ //solo (eax)
     switch(directnumb){
	case 0: //if no number
	 write_inst(first+regvalue(directstr1,2));
	   break;
	case 1://if 8bit
	 write_inst(first+0x40+regvalue(directstr1,2));
	 write_inst(rbytes[0]);  //      write_inst(rbytes[1]);
	   break;
	case 2: //32 bit number
	 write_inst(first+0x80+regvalue(directstr1,2));
         //here
         //if(letoptimize==0)
         if(islabelso)addlabeloffsetstore(off_set,islabel,labelset[parmnum],labeltmp[parmnum],4);
	 write_inst(rbytes[0]);  write_inst(rbytes[1]);
	 write_inst(rbytes[2]);  write_inst(rbytes[3]);
	 //write_inst(rbytes[4]);  write_inst(rbytes[5]);
	 //write_inst(rbytes[6]);  write_inst(rbytes[7]);
	      }//the switch
	 }//if [ 32 bit reg]
  else{ //if double (eax+eax) etc (67h prefix)
     switch(directnumb){
       case 0: //no number
	write_inst(first+0x04);
	write_inst(regvalue(directstr1,2) + (regvalue(directstr2,2) * 8));
	   break;
       case 1:// 8bit
	write_inst(first+0x44);
	write_inst(regvalue(directstr1,2) + (regvalue(directstr2,2) * 8));
	write_inst(rbytes[0]);  //write_inst(rbytes[1]);
	   break;
       case 2:// 32bit
	write_inst(first+0x84);
	write_inst(regvalue(directstr1,2) + (regvalue(directstr2,2) * 8));
        //here
        //if(letoptimize==0)
        if(islabelso)addlabeloffsetstore(off_set,islabel,labelset[parmnum],labeltmp[parmnum],4);
	write_inst(rbytes[0]);  write_inst(rbytes[1]);
	write_inst(rbytes[2]);  write_inst(rbytes[3]);
    //  write_inst(rbytes[4]);  write_inst(rbytes[5]);
    //  write_inst(rbytes[6]);  write_inst(rbytes[7]);
	   break;
     }//the switch
   }//the else
 }//the else 32bit

return 0; }



/***********************************
 Return the value of the register (eg CX=1)
************************************/
int regvalue(char *regstring,int bit){
	int a;
     switch(bit){
      case 0: for(a=0; a<8; a++) if(!stricmp(reg8[a],regstring)) return a;
	     break; //8 BIT
      case 1: for(a=0; a<8; a++) if(!stricmp(reg16[a],regstring)) return a;
	     break; //16bit
      case 2: for(a=0; a<8; a++) if(!stricmp(reg32[a],regstring)) return a;
	     break;//32bit
      case 3: for(a=0; a<8; a++) if(!stricmp(segs[a],regstring)) return a;
	     break; //segs
      case 4: for(a=0; a<8; a++) if(!stricmp(direct16[a],regstring)) return a;
	}     //bx+si etc
return 0; }


//reverse the bytes in nmber (sets *rbytes)
void reversebytes(unsigned long number){
  int tst,tst2;
  unsigned char byted[10];
	sprintf(byted,"%.8lx",number);
	//into rbytes
	//rbytes[0] is the top number 1234 = "3"412
	tst=byted[6]; if(tst>96)tst-=87; else tst-='0'; tst*=0x10;
	tst2=byted[7]; if(tst2>96)tst2-=87; else tst2-='0'; tst+=tst2;
	rbytes[0]=(unsigned char) tst;

	tst=byted[4]; if(tst>96)tst-=87; else tst-='0'; tst*=0x10;
	tst2=byted[5]; if(tst2>96)tst2-=87; else tst2-='0'; tst+=tst2;
	rbytes[1]=(unsigned char) tst;

	tst=byted[2]; if(tst>96)tst-=87; else tst-='0'; tst*=0x10;
	tst2=byted[3]; if(tst2>96)tst2-=87; else tst2-='0'; tst+=tst2;
	rbytes[2]=(unsigned char) tst;

	tst=byted[0]; if(tst>96)tst-=87; else tst-='0'; tst*=0x10;
	tst2=byted[1]; if(tst2>96)tst2-=87; else tst2-='0'; tst+=tst2;
	rbytes[3]=(unsigned char) tst;
return; }


void reverse(){ //reverse the operands
 int tst,ptr,othptr=0;
 char tmp2[MAX_LABEL_SIZE],tmp3[MAX_LABEL_SIZE];
      //tmp[50],

 //a: reverse the main str
 //b: reverse all the support strings

 if(parm_amount!=2)return; //can only handle a double
 //if(parm_amount<2)return; //can only handle a double

 ptr=1; //we start at the first operand
 //tmp[0]=asm_tmp[0]; tmp[1]=0;

 while(1){ //Get first parammeter
   tst=asm_tmp[ptr++];
   if(tst==0 || tst==',') break;
   tmp2[othptr++]=tst;
	}
 tmp2[othptr]=0;
 //ptr++; //past the coma (already done)
 othptr=0;//reset
 while(1){ //Get first parammeter
   tst=asm_tmp[ptr++];
   if(tst==0 || tst==',') break;
   tmp3[othptr++]=tst;
	}
 tmp3[othptr]=0;

 asm_tmp[1]=0;
 strcat(asm_tmp,tmp3); strcat(asm_tmp,",");
 strcat(asm_tmp,tmp2);
 //strcpy(asm_tmp,tmp);//set it

 //B: the support reversal
 tst=regsizes[0];  regsizes[0]=regsizes[1];  regsizes[1]=tst;
 tst=labelset[0];  labelset[0]=labelset[1];  labelset[1]=tst;
 tst=parmtypes[0]; parmtypes[0]=parmtypes[1]; parmtypes[1]=tst;
 strcpy(tmp2,labeltmp[0]);
 strcpy(labeltmp[0],labeltmp[1]);
 strcpy(labeltmp[1],tmp2);
// printf("Reversed to: %s\n",asm_tmp);
return; }


//read reg name and set stuff for it
//return 0 ok, else error
int read_reg(){
 char testzone[8];
 int tst,cnt=0;

 regtype=0; regnumber=0;

 while(1){
   tst=asm_tmp[mainptr];
   if(tst==',' || tst==0)break;
   mainptr++;
   testzone[cnt++]=tst;
    }
  testzone[cnt]=0;
  //find it
  tst=isreg(testzone);
  if(tst==0)return 1;

  if(tst<10){  regtype=1; regnumber=tst; return 0; }
  if(tst<20){  regtype=2; regnumber=tst-10; return 0; }
  if(tst<30){  regtype=3; regnumber=tst-20; return 0; }
  if(tst<40){  regtype=4; regnumber=tst-30; return 0; }
return 1; }

int isaspecialreg(char *str){//returns specialreg in array place+1 or 0
 int a=0;

 while(1){
       if(specialreg[a]==NULL)break;
       if(!stricmp(str,specialreg[a++]))return a;
		}
return 0; }

void do_reg_regAB(){ //Handle the REG,REG as this code is always the same
		      //Dave's idea....
  int tmp;
  if(read_reg()!=0) return;// 1;
  if(regtype==4){ error(inv_reg2,ERROR); return; }//1; }//NOT SEG reg
  if(asm_tmp[mainptr++]!=',') { error(inv_oper,ERROR); return; }// 1; }  //then MUST be ,
  tmp=regnumber-1; if(read_reg()!=0) return;// 1;
  if(regtype==4){ error(inv_reg2,ERROR); return; }// 1; }//NOT SEG reg
  regnumber--;
  write_inst(0xC0+tmp+(regnumber*8));
return; }

void number_get(int size, int parmnum){
//uses gobaltstnumber (so don't use with MOV DR0 etc
 int tst,islabel=0;
 gobaltstnumber=0;
    // (check for label id etc)
    tst=asm_tmp[mainptr];
    if(tst==1 || tst==2 || tst==3) { mainptr++; islabel=tst; }//LABEL
	    //  if(offseg==2) strcat(asm_tmp,"\3");//want the segment  0000
	    //   else strcat(asm_tmp,"\2");//want the offset   0000
	    //    strcat(asm_tmp,"\1");//normal label [0000]
    if(relative==1) add_relative_mark(size);
   //read in number
  while(1){
	tst=asm_tmp[mainptr];
	if(tst<'0' || tst>'9')break;
	mainptr++;
	gobaltstnumber*=10;
	gobaltstnumber+=tst-'0';
	}
  //LABEL POSITION IS  off_set
  if(islabel>0){
		//use parmnum to get name and mathsym
//char labeltmp[ASM_MAX_OPERANDS][MAX_LABEL_SIZE]; //name
//char labelset[ASM_MAX_OPERANDS+1];              //mathsym
		addlabeloffsetstore(off_set,islabel,labelset[parmnum],labeltmp[parmnum],size);
			}
return; }
