/* New version of SOB requires a new version of slink
   last one was too shity when linkin' several files together...
   ...This time slink'd is developed with this in mind...

        Slink 3.09
        By RodneyMcConnell
        Snakessoft
        Develop'd in just 2 daze

  Mirco linker [also acts as hexloader v2.0]


updates: Locals

   */

#define SLINK_ver_ "3.09"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define LOWBYTE(x)  ((x) & 0xff)
#define HIGHBYTE(x) (((x) >> 8) & 0xff)

unsigned int start_offset=0;
unsigned int start_seg=0;
unsigned int stack_seg=0;

unsigned int reloc_ent=0;

unsigned long cur_seg_start=0,cur_seg_ptr=0;
unsigned long org_offset=0;

unsigned int stack_size=0x200;
unsigned int mem_max=0xffff;
int malfreecntr=0,out_of_mem=0;
int error_cnt=0,warn_cnt=0;
char out_type=0,make32=0,mem_model=0;
char lose_nodata_error=0;

char case_seni=0;//can only be set with a command line +S

char mem_max_defined=0, stack_defined=0,stack_pos_defined=0,start_defined=0;

char theword[257];

char *forcename=NULL;

unsigned char *codeblock=NULL;
unsigned long codeptr=0,codelen=0;

FILE *re_hnd=NULL;
char re_dir;
char pr_str[255];
void print_f(char *str){
        if(re_dir==0)printf("%s",str);
        else if(re_hnd)fprintf(re_hnd,"%s",str);
return; }

typedef struct labels{
                char *name;
                char isseg;
                char size;
                unsigned long code_place;
                unsigned long its_seg;
                struct labels *prev;
                }labels;
labels *top_label=NULL, *cur_label;

void free_labels(){
 while(top_label){
        cur_label=top_label->prev;
        if(top_label->name){ free(top_label->name); malfreecntr--; }
        free(top_label); malfreecntr--;
        top_label=cur_label;
        }
return; }

void store_seglabel(char isseg, char sz,char *name,unsigned long plac){
 cur_label=(labels *)malloc(sizeof(labels));
 if(cur_label==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 cur_label->prev=top_label; top_label=cur_label;
 cur_label->isseg=isseg;
 cur_label->size=sz;
 cur_label->code_place=plac; 
 cur_label->its_seg=cur_seg_start;
 cur_label->name=(char *)malloc(strlen(name)+1);
 if(cur_label->name==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 strcpy(cur_label->name,name);
return; }

int find_label(char *name){//ret 0 not found
 cur_label=top_label;
 while(cur_label){
        if(case_seni){
                if(!strcmp(name,cur_label->name))return 1;
                }
        else if(!stricmp(name,cur_label->name))return 1;
        cur_label=cur_label->prev;
         }
return 0;}

typedef struct accesses{
                char *name;
                char mathsym;
                char size;
                char wantseg;
                char is_relat;
                unsigned long code_place;
                struct accesses *prev;
                }accesses;
accesses *top_access=NULL, *cur_access;

void free_accesses(){
 while(top_access){
        cur_access=top_access->prev;
        if(top_access->name){ free(top_access->name); malfreecntr--; }
        free(top_access); malfreecntr--;
        top_access=cur_access;
        }
return; }

void store_access(char isseg,char mathsym,char sz,char *name,unsigned long pla, char is_rel,char rel_size){
 cur_access=(accesses *)malloc(sizeof(accesses));
 if(cur_access==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 cur_access->prev=top_access; top_access=cur_access;
 cur_access->wantseg=isseg;
 cur_access->mathsym=mathsym;
 cur_access->size=sz; if(is_rel) cur_access->size=rel_size;
 cur_access->is_relat=is_rel;
 cur_access->code_place=pla;
 cur_access->name=(char *)malloc(strlen(name)+1);
 if(cur_access->name==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 strcpy(cur_access->name,name);
return; }

typedef struct externs{
                char *name;
                struct externs *prev;
                }externs;
externs *top_extern=NULL;

void free_externs(){
 externs *t;
 while(top_extern){
        t=top_extern->prev;
        if(top_extern->name){ free(top_extern->name); malfreecntr--; }
        free(top_extern); malfreecntr--;
        top_extern=t;
        }
return; }

void store_extern(char *name){
 externs *t;
 t=(externs *)malloc(sizeof(externs));
 if(t==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 t->prev=top_extern; top_extern=t;
 t->name=(char *)malloc(strlen(name)+1);
 if(t->name==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 strcpy(t->name,name);
return; }

void test_externs(){//all we have to do is find them
 externs *t;
 t=top_extern;
 while(t){
          if(find_label(t->name)==0){
                                   error_cnt++;
                                   sprintf(pr_str,"ERROR: Unresolved extern %s\n",t->name);
                                   print_f(pr_str);
                                        }
          t=t->prev;
                }
return; }

typedef struct the_segs{
               unsigned char *code;
               char *name;
               char sz;
               long codelen;
               long codelenptr;
               struct the_segs *prev;
                }the_segs;
the_segs *top_seg=NULL,*cur_seg;

void free_thesegs(){
 while(top_seg){
               cur_seg=top_seg->prev;
               if(top_seg->code){ free(top_seg->code); malfreecntr--; }
               if(top_seg->name){ free(top_seg->name); malfreecntr--; }
               free(top_seg); malfreecntr--;
               top_seg=cur_seg;
                }
return; }

int find_seg(char *name){
 cur_seg=top_seg;
 while(cur_seg){
               if(case_seni){
                        if(!strcmp(cur_seg->name,name))return 1;
                                }
               else if(!stricmp(cur_seg->name,name))return 1;
               cur_seg=cur_seg->prev;
                }
return 0; }

void make_seg(char sz,char *name){
 the_segs *tsg;
 cur_seg=(the_segs *)malloc(sizeof(the_segs));
 if(cur_seg==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 cur_seg->code=NULL;
 cur_seg->sz=sz;
 cur_seg->codelen=0; cur_seg->codelenptr=0;
 cur_seg->prev=NULL;
 if(top_seg==NULL) top_seg=cur_seg;
 else{ tsg=top_seg; while(tsg->prev)tsg=tsg->prev;
       tsg->prev=cur_seg;
                }
 cur_seg->name=(char *)malloc(strlen(name)+1);
 if(cur_seg->name==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 strcpy(cur_seg->name,name);
return; }

//A read in each segment
FILE *in_hnd;

typedef struct reloc_t{
                unsigned long addr;
                struct reloc_t *prev;
                }reloc_t;
reloc_t *top_reloc=NULL;

void writeaddress(FILE *hnd, unsigned long num){
 unsigned char n1=0,n2=0,n3=0,n4=0;
 unsigned int h1,h2;
 h1=num/0x10000;
 h2=num-(h1*0x10000);
 n1=LOWBYTE(h1);
 n2=HIGHBYTE(h1);
 n3=LOWBYTE(h2);
 n4=HIGHBYTE(h2);

  fputc(n3,hnd);  fputc(n4,hnd);
  fputc(n1,hnd);  fputc(n2,hnd);

return; }

int dump_reloc(FILE *hnd,int loc){
  reloc_t *t=top_reloc;
  while(t){
             writeaddress(hnd, t->addr);
             loc+=4;
             t=t->prev;
                }
return loc; }

void free_reloc(){
 reloc_t *t;
 while(top_reloc){
        t=top_reloc->prev;
        free(top_reloc);  malfreecntr--;
        top_reloc=t;
        }
return; }

void store_reloc_entry(unsigned long addr){
 reloc_t *t;
 t=(reloc_t *)malloc(sizeof(reloc_t));
 if(t==NULL){ out_of_mem=1; return; }
 malfreecntr++;
 t->prev=top_reloc; top_reloc=t;
 t->addr=addr;
 reloc_ent++;
return; }

unsigned long getnumber(unsigned long addr, int size){
 unsigned long num=0;
 unsigned char n1=0,n2=0,n3=0,n4=0;

 n1=codeblock[addr+3];
 n2=codeblock[addr+2];
 n3=codeblock[addr+1];
 n4=codeblock[addr+0];
 switch(size){
        case 1: num=n4; break;//8bit
        case 2: num=n4+(n3*0x100); break;//16bit
        default: num=n4+(n3*0x100)+(n2*0x10000)+(n1*0x1000000); break;//32bit
                }
 //sprintf(pr_str,">addr = %lu ,NUM %ld  (size =%c) (%d %d)<\n",addr,num,size,n4,n3);
 //print_f(pr_str);
return num; }

void setnumber(unsigned long offset, int size, unsigned long num){
 unsigned char n1=0,n2=0,n3=0,n4=0;
 unsigned int h1,h2;
 h1=num/0x10000;
 h2=num-(h1*0x10000);
 n1=LOWBYTE(h1);
 n2=HIGHBYTE(h1);
 n3=LOWBYTE(h2);
 n4=HIGHBYTE(h2);
//sprintf(pr_str,"%d %d %d %d\n",n1,n2,n3,n4);
//print_f(pr_str);
 switch(size){
        case 1: codeblock[offset]=n3;
                  break;
        case 2: codeblock[offset+0]=n3;
                  codeblock[offset+1]=n4;
                  break;
        default:  codeblock[offset+0]=n3;
                  codeblock[offset+1]=n4;
                  codeblock[offset+2]=n1;
                  codeblock[offset+3]=n2;
                }
// sprintf(pr_str,"Size %c addr=%ld to %ld (%d %d)\n",size,offset,num,n4,n3);
// print_f(pr_str);
return; }

void do_rel(char size,unsigned long des_place,unsigned long la_addr){
 if(codeblock==NULL)return;
 if(size>='0')size-='0';
 la_addr=la_addr-(des_place+size);
 setnumber(des_place,size,la_addr);
return; }

void adjust_offset(char mathsym, char size, unsigned long des_place, unsigned long act_offset){
 unsigned long num;
 if(codeblock==NULL)return;

 if(size>='0')size-='0';
 num=getnumber(des_place,size);
 switch(mathsym){
                case '-': num=act_offset-num; break;
                case '+': num=act_offset+num; break;
                case '/': if(num>0)num=act_offset/num;
                          else num=act_offset;
                           break;
                case '*': num=act_offset*num; break;
                case '^': num=act_offset^num; break;
                case '|': num=act_offset|num; break;
                case '&': num=act_offset&num; break;
                case '%': if(num>0)num=act_offset%num;
                          else num=act_offset;
                           break;
                case '>': num=act_offset>>num; break;
                case '<': num=act_offset<<num; break;
                default: num=act_offset;
                        }
  setnumber(des_place,size,num);
return; }

void store_byte(unsigned char byt){
         if(codeblock==NULL){
                    codeblock=(char *)malloc(0x100);
                    if(codeblock==NULL){ out_of_mem=1; return; }
                    malfreecntr++;
                    codelen=0x100;
                                }
          else{
                if(codeptr>=codelen-5){
                     codeblock=(char *)realloc(codeblock,codelen+0x100);
                     if(codeblock==NULL){ malfreecntr--;
                                              out_of_mem=1; return; }
                     codelen+=0x100;
                                    }
                                }
          codeblock[codeptr++]=byt;
          cur_seg_ptr++;
return; }

void add_byte(unsigned char byt){
 if(cur_seg==NULL)make_seg('2'+make32,"code");
 if(cur_seg){
         if(cur_seg->code==NULL){
                    cur_seg->code=(char *)malloc(0x100);
                    if(cur_seg==NULL){ out_of_mem=1; return; }
                    malfreecntr++;
                    cur_seg->codelenptr=0x100;
                                }
          else{
                if(cur_seg->codelen>=cur_seg->codelenptr-5){
                     cur_seg->code=(char *)realloc(cur_seg->code,cur_seg->codelenptr+0x100);
                     if(cur_seg->code==NULL){ malfreecntr--;
                                              out_of_mem=1; return; }
                     cur_seg->codelenptr+=0x100;
                                    }
                                }
          cur_seg->code[cur_seg->codelen++]=byt;
                        }
return; }


void read_word(FILE *hnd){
 int cntr=0;
 char k;
 for(;;){
    k=fgetc(hnd);
    if(k<1 || k=='\n')break;
    theword[cntr++]=k;
        }
 theword[cntr]=0;
return; }

unsigned long get_da_num(FILE *hnd){
 unsigned long num=0;
 char k;
 for(;;){
        k=toupper(fgetc(hnd));
        if(k>='0' && k<='9') { num*=0x10; num+=k-'0'; }
        else if(k>='A' && k<='F') { num*=0x10; num+=(k-'A')+10; }
        else break;
                }
return num; }


int todecimal(char k){
 int num=0;
        k=toupper(k);
        if(k>='0' && k<='9') num=k-'0';
        else if(k>='A' && k<='F') num=(k-'A')+10;
return num; }

int read_it(char *fname){
 long num;
 char k,k2;
 if(fgetc(in_hnd)!=0x19 ||
    fgetc(in_hnd)!=0x76 ){ error_cnt++; sprintf(pr_str,"ERROR: %s is not a valid SOB or LIB file\n",fname);
                                        print_f(pr_str);
                                        return 1; }
 fgetc(in_hnd);//past the /n after id
 for(;;){
      k=fgetc(in_hnd);
      if(k==-1 || k==0)break;
      if(k=='\n')add_byte(k);
      else if(k=='#'){
               k=fgetc(in_hnd);
               switch(k){
                        case 'S'://xLABEL define segment x=size
                                k=fgetc(in_hnd);
                                read_word(in_hnd);
                                if(find_seg(theword)==0)make_seg(k,theword);
                                break;
                        case 'o'://xxLABEL offset access  xx=mathsym,size
                        case 's'://xxLABEL segment access xx=mathsym,size
                        case 'r'://X relativeoffset(X==size)
                        case 'O'://xLABEL define offset: x=size
                        case 'E'://LABEL extern label
                             add_byte('#');
                             add_byte(k);
                             for(;;){ k=fgetc(in_hnd);
                                      if(k<1 || k=='\n')break;
                                      add_byte(k);
                                              }//for
                             add_byte('\n');
                         break;
                        case 'd'://X xxxx directive X xxxx
                           switch(fgetc(in_hnd)){
                                        case 'r'://org offset
                                              org_offset=get_da_num(in_hnd);
                                                break;
                                        case 'd':
                                                fgetc(in_hnd);//past the \n
                                                lose_nodata_error=1;
                                                break;
                                        case 'T'://x outtype
                                                k=fgetc(in_hnd);
                                                fgetc(in_hnd);//past the \n
                                                //'0'=exe,'1'=com,'2'=lib
                                                if(out_type==0)out_type=k;
                                                else if(out_type!=k){ warn_cnt++;
                                                                sprintf(pr_str,"WARNING: File %s has different outtype",fname);
                                                                print_f(pr_str);
                                                                }
                                                break;
                                        case 'M'://x mem model
                                                k=fgetc(in_hnd);
                                                fgetc(in_hnd);//past the \n
                                                if(mem_model==0) mem_model=k;
                                                else if(mem_model!=k){ warn_cnt++;
                                                                        sprintf(pr_str,"WARNING: Linking different mem models with %s",fname);
                                                                        print_f(pr_str);
                                                                        }
                                                break;
                                        case '3'://out32
                                                k=fgetc(in_hnd);
                                                fgetc(in_hnd);//past the \n
                                                if(make32==0)make32=k;
                                                else if(make32=='1'){
                                                              if(k=='0'){warn_cnt++;
                                                                        sprintf(pr_str,"WARNING: Linking 32bit to 16bit with file %s\n",fname);
                                                                        print_f(pr_str);
                                                                                }
                                                                }
                                                else{
                                                     if(k=='1'){warn_cnt++;
                                                               sprintf(pr_str,"Linking 16bit to 32bit with file %s\n",fname);
                                                               print_f(pr_str);
                                                                    }
                                                                }
                                                break;
                                        case 'S':
                                                if(start_defined==1){
                                                             warn_cnt++;
                                                             sprintf(pr_str,"WARNING: Start redefined in file %s\n",fname);
                                                             print_f(pr_str);
                                                                }
                                                start_defined=1;
                                                fgetc(in_hnd);//past the \n
                                                add_byte('#');
                                                add_byte('d');
                                                add_byte('S');
                                                add_byte('\n');
                                                 break;
                                        case 't'://stackseg
                                                if(stack_pos_defined==1){
                                                                warn_cnt++;
                                                                sprintf(pr_str,"WARNING: Stack seg redefined in file %s\n",fname);
                                                                print_f(pr_str);
                                                                }
                                                stack_pos_defined=1;
                                                add_byte('#');
                                                add_byte('d');
                                                add_byte('t');
                                                add_byte('\n');
                                                break;
                                        case 's'://xxxxxxxx
                                                num=get_da_num(in_hnd);
                                                if(stack_defined==1 && stack_size!=num){
                                                        warn_cnt++;
                                                        sprintf(pr_str,"WARNING: Stack size redefined in file %s\n",fname);
                                                        print_f(pr_str);
                                                        }
                                                stack_size=num;
                                                stack_defined=1;
                                                if(out_type=='1'){
                                                           warn_cnt++;
                                                           sprintf(pr_str,"WARNING: Stack defined but output is COM file (in %s)\n",fname);
                                                           print_f(pr_str);
                                                                }
                                                break;
                                        case 'm'://xxxx
                                                num=get_da_num(in_hnd);
                                                if(mem_max_defined==1 && mem_max!=num){
                                                        warn_cnt++;
                                                        sprintf(pr_str,"WARNING: MaxMem size redefined in file %s\n",fname);
                                                        print_f(pr_str);
                                                        }
                                                mem_max_defined=1;
                                                mem_max=num;
                                                if(out_type=='1'){
                                                           warn_cnt++;
                                                           sprintf(pr_str,"WARNING: MaxMem defined but output is COM file (in %s)\n",fname);
                                                           print_f(pr_str);
                                                                }
                                                 break;
                                                }
                         break;
                         default://skip
                             for(;;){ k=fgetc(in_hnd);
                                      if(k<1 || k=='\n')break;
                                              }//for
                                }//switch
                        }//#
       else{
             add_byte(k);
             k2=fgetc(in_hnd); 
             if(k2>0 && k2!='#')add_byte(k2);
             else ungetc(k2,in_hnd);
                }
        }
return 0; }

int dump_lib(char *fname){
 int cn;
 long cntr;
 FILE *out_fp;

 strcpy(theword,fname);
 for(cn=0;cn<strlen(theword);cn++) if(theword[cn]=='.'){ theword[cn]=0; break; }
 strcat(theword,".LIB");

 out_fp=fopen(theword,"w");
 if(out_fp){
  fprintf(out_fp,"%c%c\n",0x19,0x76);//sob id
  fprintf(out_fp,"##\n## Snakessoft Linker Library File\n");//text string
  fprintf(out_fp,"##\n## SLINK %s Generated file\n##\n",SLINK_ver_);
            cur_seg=top_seg;
            while(cur_seg){
                   fprintf(out_fp,"#S%c%s\n",cur_seg->sz,cur_seg->name);
                   for(cntr=0; cntr<cur_seg->codelen;cntr++){
                                      fprintf(out_fp,"%c",cur_seg->code[cntr]);
                                        }
                   cur_seg=cur_seg->prev;
                        }
//dump some directives (NOT OUTTYPE!!!)
         if(lose_nodata_error) fprintf(out_fp,"#dd\n");
         if(org_offset)fprintf(out_fp,"#dr%.8lx\n",org_offset);
         if(out_type && out_type!='2')fprintf(out_fp,"#dT%c\n",out_type);
         if(mem_model)fprintf(out_fp,"#dM%c\n",mem_model);
         if(make32)fprintf(out_fp,"#d3%c\n",make32);
         if(stack_defined)fprintf(out_fp,"#ds%.8x\n",stack_size);
         if(mem_max_defined)fprintf(out_fp,"#dm%.4x\n",mem_max);

         fclose(out_fp);
                }
 else { error_cnt++; sprintf(pr_str,"ERROR: Couldn't open output file\n");
                     print_f(pr_str); return 1; }
return 0; }

void dump_exe_header(FILE *hnd){
 unsigned char k;//,use_stk_seg=0;
 unsigned long num;
 int loc=0;
 int RELOC_TABLE_ADD=0x40;     // start of the relocation table (last thing in header)
 unsigned int header_size;

       header_size=((reloc_ent*4)+RELOC_TABLE_ADD);
       if(header_size<512)header_size=512;
       if(header_size%16!=0) header_size+=header_size%16;

        //EXE HEADER (ARGH!!!)
        fputc(0x4D,hnd); 
        fputc(0x5A,hnd);//ID 00h

        num=codeptr%512;
        if(num<0xFFFF) num++;
        k=num; fputc(k,hnd);
        k=num>>8; fputc(k,hnd);// 02h bytes in largest block

        //num=(topobject.procsize+15)/16;
        num=(codeptr+header_size)/512;
        if((codeptr+header_size)%512!=0)num++;
        //if(num<0xFFFF)num++;
        k=num; fputc(k,hnd);
        k=num>>8; fputc(k,hnd); // 04h number of blocks

        //get number of entries(max 65535)

        k=reloc_ent;fputc(k,hnd);
        k=reloc_ent>>8;fputc(k,hnd); // 06h relocation entries (max 65535)

        //get size of reloc table file +15/16, if <32 (512) then = 32
        num=header_size/16; if(num<32)num=32;
        k=num; fputc(k,hnd);
        k=num>>8; fputc(k,hnd); // 08h blocks in header

        num=(codeptr+15)/16;
        num+=(stack_size+15)/16;//add stack size
        //if(num>4) num-=4 //TASM has same as us but 4 less

        if(num<0xffff)num++;
        k=num; fputc(k,hnd);
        k=num>>8; fputc(k,hnd);// 0ah min blocks needed

        //if(num<mem_max)num=mem_max;
        num+=mem_max;
        if(num>0xFFFF){
                k=0xff; fputc(k,hnd);
                k=0xff; fputc(k,hnd);
                        }
        else{
                k=num; fputc(k,hnd);
                k=num>>8; fputc(k,hnd);//max blocks needed
                }

        if(stack_pos_defined) num=stack_seg;
        else{   num=(codeptr+15)/16;
                if(num==0)num=1;
                if(num<0xffff)num++;
                }
        k=num;fputc(k,hnd);
        k=num>>8;fputc(k,hnd); // 0eh stack address

        k=stack_size; fputc(k,hnd);
        k=stack_size>>8; fputc(k,hnd); // 10h stack size

        fputc(0,hnd);
        fputc(0,hnd);//12h checksum

        k=start_offset; fputc(k,hnd);
        k=start_offset>>8; fputc(k,hnd);//14h start address
        
        k=start_seg;fputc(k,hnd);
        k=start_seg>>8;fputc(k,hnd);//16h start of code segment CS
        
        k=RELOC_TABLE_ADD; fputc(k,hnd);
        k=RELOC_TABLE_ADD>>8; fputc(k,hnd);//18h relocation table address

        fputc(0,hnd); //1Ah    //number of overlays
        loc=0x1b;

        //write version etc till RELOC_TABLE_ADD
        //        fputc(0,hnd);//add a space
        //        //linker version is told by  S:x)S   x = version
        //        fputc('S',hnd);
        //        fputc(':',hnd);
        //        fputc(SLINK_vernum_,hnd);
        //        fputc(')',hnd);
        //        fputc('S',hnd);
        //        fputc(0,hnd); //final test 0 Rd
        //        fputc('R',hnd);
        //        fputc('d',hnd);
        //        loc+=9;

        //DUMP RELOC TABLE
       if(loc<RELOC_TABLE_ADD){//skip to it
                for(;loc<RELOC_TABLE_ADD;loc++) fputc(0,hnd);
                    }
       loc=dump_reloc(hnd,loc);

        //after exeheader+reloc table
       if(loc<512){//make it 512
                for(;loc<512;loc++) fputc(0,hnd);
                    }
       else while(1){//add 0 till multiple of 16
                if(loc%16==0)break;
                fputc(0,hnd);
                loc++;
                   }
return; }


int link_A(){//produce 1 big code block
 int cntr;
 char had_data=0;
 the_segs *big_seg,*tsg;
 big_seg=(the_segs *)malloc(sizeof(the_segs));
 if(big_seg==NULL){ out_of_mem=1; return 1; }
 malfreecntr++;
 cur_seg=big_seg;
 cur_seg->code=NULL; cur_seg->sz=0;
 cur_seg->codelen=0; cur_seg->codelenptr=0;
 cur_seg->prev=NULL; cur_seg->name=NULL;
 tsg=top_seg;
 while(tsg){
            if(stricmp(tsg->name,"data")){//not data, copy it then
                   sprintf(theword,"#S%c%s\n",tsg->sz,tsg->name);
                   for(cntr=0;cntr<strlen(theword);cntr++)
                                      add_byte(theword[cntr]);
                   for(cntr=0; cntr<tsg->codelen;cntr++)
                                      add_byte(tsg->code[cntr]);
                               }
            tsg=tsg->prev;
            }
 //find data seg...
 tsg=top_seg;
 while(tsg){
              if(!stricmp(tsg->name,"data")){
                   sprintf(theword,"#S%c%s\n",tsg->sz,tsg->name);
                   for(cntr=0;cntr<strlen(theword);cntr++)
                                      add_byte(theword[cntr]);
                   for(cntr=0; cntr<tsg->codelen;cntr++)
                                      add_byte(tsg->code[cntr]);
                   had_data=1;
                   break;
                                        }
              tsg=tsg->prev;
                }
 add_byte(0);add_byte(0);//indicate the end
 if(out_type=='1' || out_type==1)had_data=1;//com has no data
 if(lose_nodata_error==0 && had_data==0){warn_cnt++;
                 sprintf(pr_str,"WARNING: program has no data segment\n");
                 print_f(pr_str);
                        }
 free_thesegs();
 cur_seg=top_seg=big_seg;
return 0; }

unsigned long cptr;
void get_the_next_word(){
 int cntr=0;
 char k;
 for(;;){
      k=top_seg->code[cptr++];
      if(k=='\n' || k==0)break;
      theword[cntr++]=k;
      }
 theword[cntr]=0;
return; }

void skiptoeol(){
 char k;
 for(;;){
      k=top_seg->code[cptr++];
      if(k=='\n' || k==0)break;
              }
return; }

void make_16(){
 for(;;){
        if(codeptr%16==0)break;
        store_byte(0);
                }
return; }

int link_B(){//to binary, getting variables etc...
 char k,ma;
 unsigned char byt;
 char next_is_relative=0, next_rel_size=0;

 cptr=0;
 if(top_seg==NULL || top_seg->code==NULL)return 1;
 for(;;){
        k=top_seg->code[cptr++];
        if(k==0)break;
        if(k=='\n');
        else if(k=='#'){
               k=top_seg->code[cptr++];
               switch(k){
                        case 'S'://xLABEL define segment x=size
                                k=top_seg->code[cptr++];
                                get_the_next_word();
                                make_16();
                                cur_seg_start=codeptr/16;
                                cur_seg_ptr=0; //org_offset=0;
                                store_seglabel(1,k,theword,codeptr);
                                break;
                        case 'o'://xxLABEL offset access  xx=mathsym,size
                                ma=top_seg->code[cptr++];
                                k=top_seg->code[cptr++];
                                get_the_next_word();
                                store_access(0,ma,k,theword,codeptr,next_is_relative,next_rel_size);
                                next_is_relative=0; next_rel_size=0;
                                break;
                        case 's'://xxLABEL segment access xx=mathsym,size
                                ma=top_seg->code[cptr++];
                                k=top_seg->code[cptr++];
                                get_the_next_word();
                                store_access(1,ma,k,theword,codeptr,next_is_relative,next_rel_size);
                                break;
                        case 'r'://X relativeoffset(X==size)
                                next_rel_size=top_seg->code[cptr++];
                                next_is_relative=1;
                                break;
                        case 'O'://xLABEL define offset: x=size
                                k=top_seg->code[cptr++];
                                get_the_next_word();
                                store_seglabel(0,k,theword,cur_seg_ptr+org_offset);
                                break;
                        case 'E'://LABEL extern label
                                get_the_next_word();
                                store_extern(theword);
                                break;
                        case 'd'://X xxxx directive X xxxx
                           switch(top_seg->code[cptr++]){
                                        case 'T':
                                        case 'M':
                                        case '3':
                                        case 's':
                                        case 'm':
                                                skiptoeol();
                                                break;
                                        case 'S':
                                                start_offset=cur_seg_ptr;
                                                start_seg=cur_seg_start;
                                                 break;
                                        case 't'://stackseg
                                                stack_seg=cur_seg_start;
                                                break;
                                                }
                         break;
                         default: skiptoeol();
                                }//switch
                        }//#
        else{
                byt=todecimal(k)*0x10;
                byt+=todecimal(top_seg->code[cptr++]);
                store_byte(byt);
                   }
           }
 test_externs();
return 0; }

int link_C(){//sort the addresses
 char ret=0;
 accesses *t;
 t=top_access;
 while(t){
            if(find_label(t->name)==0){
                              error_cnt++;
                              sprintf(pr_str,"ERROR: Missing Label %s\n",t->name);
                              print_f(pr_str);
                              ret=1;
                                }
            else{
                if(t->is_relat){
                     do_rel(t->size,t->code_place,cur_label->code_place);
                                }
                else{
                     if(t->wantseg){ adjust_offset(t->mathsym, t->size, t->code_place, cur_label->its_seg);
                                     store_reloc_entry(t->code_place);
                                        }
                     else adjust_offset(t->mathsym, t->size, t->code_place,cur_label->code_place);
                            }
                        }
             t=t->prev;
                }
return ret; }

int link_D(char *fname){//dump the program
 int cn;
 unsigned long our_ptr;
 FILE *outfp;
 if(codeblock==NULL)return 1;

 strcpy(theword,fname);
 for(cn=0;cn<strlen(theword);cn++) if(theword[cn]=='.'){ theword[cn]=0; break; }
 if(out_type!='1' && out_type!=1)strcat(theword,".EXE");
 else strcat(theword,".COM");

 outfp=fopen(theword,"wb");
 if(outfp){
        if(out_type==0 || out_type=='0') dump_exe_header(outfp);
         for(our_ptr=0; our_ptr<codeptr; our_ptr++)
                fputc(codeblock[our_ptr],outfp);
         fclose(outfp);
         }
 else return 1;
return 0; }

typedef struct filehold{
                char *name;
                struct filehold *prev;
                }filehold;
filehold *top_filecomp;

int storefiletolink(char *name){
  filehold *tmpf;
  int cn,had=0;

  tmpf=(filehold *)malloc(sizeof(filehold));
  if(tmpf==NULL){ out_of_mem=1; return 1; }
  malfreecntr++;

  tmpf->prev=top_filecomp; top_filecomp=tmpf;

  tmpf->name=(char *)malloc(strlen(name)+5);
  if(tmpf->name==NULL){ out_of_mem=1; return 1; }
  malfreecntr++;
  strcpy(tmpf->name,name);

  for(cn=strlen(tmpf->name); cn>0; cn--)
                              if(tmpf->name[cn]=='.'){ had=1; break; }
  if(had==0)strcat(tmpf->name,".sob");
return 0; }

void free_storedfilenames(){
  filehold *tmpf;
  while(top_filecomp){
            tmpf=top_filecomp->prev;
            if(top_filecomp->name){ free(top_filecomp->name);
                                    malfreecntr--; }
            free(top_filecomp); malfreecntr--;
            top_filecomp=tmpf;
                }
return; }


int read_infiles(){
 int a;
 filehold *tmpf=top_filecomp;

 while(tmpf){
         if(tmpf->name){
             if(forcename==NULL)forcename=tmpf->name;
             in_hnd=fopen(tmpf->name,"r");
             if(in_hnd==NULL){ sprintf(pr_str,"Cannot Open File %s\n",tmpf->name);
                               printf(pr_str);
                            return 1; }
             a=read_it(tmpf->name);
             fclose(in_hnd);
             if(a)return 1;
                }
          tmpf=tmpf->prev;
            }
return 0; }


char *re_name;
void main(int argc, char **argv){
 int a;
 short had1=0;

 re_dir=0; re_name=NULL;
 if(argc>1)
    for(a=argc-1; a>0; a--){
            if(a>0 && !stricmp(argv[a-1],"-O")){//set output name
                                forcename=argv[a];
                                a--;
                                }
            else if(!stricmp(argv[a],"-S"))case_seni=1;
            else if(argv[a][0]=='>'){ re_dir=1;
                                      re_name=argv[a]+1;
                                        }
            else{   had1=1;
                    if(argv[a][0])if(storefiletolink(argv[a]))break;
                        }
              }
 if(re_dir){
        re_hnd=fopen(re_name,"w");
        if(re_hnd==NULL)re_dir=0;
                }

 sprintf(pr_str,"SLINK %s:\n(c)2001 Snakesoft/Rodney McConnell (snakessoft@yahoo.co.uk, breed@mindless.com)\n",SLINK_ver_);
 print_f(pr_str);
 sprintf(pr_str,"Visit the home of snakessoft http://www.geocities.com/snakessoft\n\n");
 print_f(pr_str);
 if(had1==0){ sprintf(pr_str,"Usage: slink filename.sob\n");
              print_f(pr_str); if(re_hnd)fclose(re_hnd); exit(-1); }

 if(out_of_mem==1){ sprintf(pr_str,"Out of Memory...\n"); print_f(pr_str);if(re_hnd)fclose(re_hnd); exit(-1); }

 a=read_infiles();
 if(out_of_mem==1){ sprintf(pr_str,"Out of Memory...\n"); print_f(pr_str);if(re_hnd)fclose(re_hnd); exit(-1); }

 if(a==0){
        if(out_type==2 || out_type=='2') a=dump_lib(forcename);
        else{
                 a=link_A();//to one big block
                 if(a==0)a=link_B();//to binary, getting variables etc...
                 if(a==0)a=link_C();//all the address sorted
                 if(a==0)a=link_D(forcename);//output the exe/com
                 }
           }
 if(out_of_mem==1){ sprintf(pr_str,"Out of Memory...\n"); print_f(pr_str);if(re_hnd)fclose(re_hnd); exit(-1); }

 if(a==0){ sprintf(pr_str,"\nSLINK Operation complete...\n"); print_f(pr_str);
                        }
 free_storedfilenames();
 if(codeblock){ free(codeblock); malfreecntr--; codeblock=NULL; }
 free_thesegs();
 free_labels();
 free_accesses();
 free_externs();
 free_reloc();
 if(malfreecntr!=0){sprintf(pr_str,"Memory Error (%d)\n",malfreecntr);
                        print_f(pr_str); }
 if(re_hnd)fclose(re_hnd);
return; }


